!-------------------------------------Differential Equations-------------------------
Function ODEfunction(t,y,neqn)
 Use Double_Precision
 Use Variable_Library
 Implicit None
 Integer,Intent(in) :: neqn
 Real(dp),Intent(in) :: t
 Real(dp),Dimension(:),Intent(in) :: y
End Function ODEfunction
!-------------------------------------Differential Equations-------------------------

!-------------------------------------Ron Kutta Method-------------------------------
SUBROUTINE RKF(tstart,tend,y,neqn,f,H,Hmin,Hmax,epsi1,epsi2,exitflag) 
 USE Variable_Library 
 Use Double_Precision
 INTEGER,INTENT(IN) :: neqn 
 Character,INTENT(OUT) :: exitflag 
 REAL(dp),INTENT(IN) :: epsi1, epsi2, Hmin, Hmax, tstart, tend 
 Real(dp),Intent(INOUT) :: H
 REAL(dp),Dimension(:),INTENT(INOUT) :: y 
 INTERFACE 
   FUNCTION ODEfunction(t,y,neqn) 
     Integer,Intent(in) :: neqn
     Real(dp),Intent(in) :: t
     Real(dp),Dimension(:),Intent(in) :: y 
   END FUNCTION ODEfunction 
 END INTERFACE 
End Subroutine RFK
!-------------------------------------Ron Kutta Method-------------------------------

!-------------------------------------Error Function---------------------------------
Function Error(x)
 Use Double_Precision
 Implicit None
  REAL(dp),INTENT(IN) :: x
  Interface
    Subroutine RKF(t1.t2,y,neqn,H,H1,H2,epsi1,epsi2,exitflag)
      INTEGER,INTENT(IN) :: neqn
      Character,INTENT(OUT) :: exitflag
      REAL(dp),INTENT(IN) :: epsi1, epsi2, H1, H2, t1, t2
      REAL(dp),INTENT(INOUT) :: H
      REAL(dp),DIMENSION(:),INTENT(INOUT) :: y
      INTERFACE
        FUNCTION ODEfunction(t,y,neqn)
          INTEGER,INTENT(IN) :: neqn
          REAL(dp),INTENT(IN) :: t
          REAL(dp),DIMENSION(:),INTENT(IN) :: y
        END FUNCTION ODEfunction
      END INTERFACE
    END SUBROUTINE RKF 
  END INTERFACE
End Function

!-------------------------------------Error Function---------------------------------

!-------------------------------------Secant Method----------------------------------
Subroutine Secant_Method(x,x1,x2,x3,trueerror,E1)
 Use Double_Precision
 Implicit None
   Real(dp),Intent(inout) :: x1, x2
   Real(dp),Intent(out) :: X3, trueerror, E1
   Interface
     Function Error(x)
       REAL(dp),INTENT(IN) :: X
     End Function Error(x)
   End Interface
End Subroutine Secant_Method
!-------------------------------------Secant Method----------------------------------
