Program Snail_Worm_Population
!========================================================================================
!
!
!
!
!
!
!
!
!
!
!========================================================================================
  Use Double_Precision
  Use Variable_Library
  Implicit None
  Real(dp) :: yold, yolder, delta, root, tstart, treport, tend, epsi1, epsi2, &
              &bound, bound1, bound2
  REAL(dp),Dimension(:),ALLOCATABLE :: Population_Density 
  Integer :: i, ntimes=15, t, neqn
  Character :: ANS, exitflag
  Interface
   !-------------------------------------Ron Kutta Method-------------------------------
   SUBROUTINE RKF(tstart,tend,y,neqn,H,Hmin,Hmax,epsi1,epsi2,exitflag) 
    Use Double_Precision
    INTEGER,INTENT(IN) :: neqn 
    Character,INTENT(OUT) :: exitflag 
    REAL(dp),INTENT(IN) :: epsi1, epsi2, Hmin, Hmax, tstart, tend 
    Real(dp),Intent(INOUT) :: H
    REAL(dp),Dimension(:),INTENT(INOUT) :: y 
    INTERFACE 
     FUNCTION ODEfunction(t,y,neqn) 
      Use Double_Precision
      Integer,Intent(in) :: neqn
      Real(dp),Intent(in) :: t
      Real(dp),Dimension(:),Intent(in) :: y 
     END FUNCTION ODEfunction 
    END INTERFACE 
   End Subroutine Rkf
   !-------------------------------------Error Function---------------------------------
   Function Error(x)
     Use Double_Precision
     REAL(dp),INTENT(IN) :: x
     Interface
      Subroutine RKF(tstart,tend,y,neqn,H,Hmin,Hmax,epsi1,epsi2,exitflag)
       Use Double_Precision
       INTEGER,INTENT(IN) :: neqn
       Character,INTENT(OUT) :: exitflag
       REAL(dp),INTENT(IN) :: epsi1, epsi2, Hmin, Hmax, tstart, tend
       REAL(dp),INTENT(INOUT) :: H
       REAL(dp),DIMENSION(:),INTENT(INOUT) :: y
       INTERFACE
        FUNCTION ODEfunction(t,y,neqn)
          Use Double_Precision
          INTEGER,INTENT(IN) :: neqn
          REAL(dp),INTENT(IN) :: t
          REAL(dp),DIMENSION(:),INTENT(IN) :: y
        END FUNCTION ODEfunction
       END INTERFACE
      END SUBROUTINE RKF 
     END INTERFACE
   End Function
   !-------------------------------------Secant Method----------------------------------
   Subroutine Secant_Method(x1,x2,x3,flag)
    Use Double_Precision
    Real(dp),Intent(inout) :: x1, x2
    Real(dp),Intent(out) :: X3
    CHARACTER,INTENT(OUT) :: flag
    Interface
      Function Error(x)
       Use Double_Precision
       REAL(dp),INTENT(IN) :: x
       Interface
        Subroutine RKF(tstart,tend,y,neqn,H,Hmin,Hmax,epsi1,epsi2,exitflag)
         Use Double_Precision
         INTEGER,INTENT(IN) :: neqn
         Character,INTENT(OUT) :: exitflag
         REAL(dp),INTENT(IN) :: epsi1, epsi2, Hmin, Hmax, tstart, tend
         REAL(dp),INTENT(INOUT) :: H
         REAL(dp),DIMENSION(:),INTENT(INOUT) :: y
         INTERFACE
          FUNCTION ODEfunction(t,y,neqn)
           Use Double_Precision
           INTEGER,INTENT(IN) :: neqn
           REAL(dp),INTENT(IN) :: t
           REAL(dp),DIMENSION(:),INTENT(IN) :: y
          END FUNCTION ODEfunction
         END INTERFACE
        END SUBROUTINE RKF 
       END INTERFACE
      End Function Error
    End Interface
   End Subroutine Secant_Method
  End Interface

   DO
      !Ask for all variables
!      WRITE(*,'(A)',ADVANCE="NO") "What is the starting and ending year(separated by &
!                                   &commas : "
!      READ(*,*) tstart, tend
      WRITE(*,'(A)',ADVANCE="NO") "Enter the number of differential equations: "
      READ(*,*) neqn
!     WRITE(*,'(A)',ADVANCE="NO") "Enter error magnitude boundaries (upper and lower) &
!                                   &separated by commas): "
!     READ(*,*) epsi1, epsi2
      WRITE(*,'(A)',ADVANCE="NO") "Estimate of initial worm population density (#/m^2): "
      READ(*,*) yolder
      !compute error w/ this stimate
      delta = Error(yolder)
      write(*,*) "delta= ", delta
      WRITE(*,*) "The error meeting the target population is ", delta
      WRITE(*,'(A)',ADVANCE="NO") "Satisfied with this estimate (Y/N)? "
      READ(*,*) ANS
      IF (ANS=="Y") EXIT
    END DO
    tstart = 0.0
    treport = 0.5
    bound = 0.25
    bound1 = 0.00001
    bound2 = 0.5
    epsi1 = 1E-6
    epsi2 = 0.5
    ALLOCATE(Population_Density(neqn))
    Population_Density(1) = 30
    Population_Density(2) = root
    IF (delta.LT.0) THEN
      yold = yolder*1.2
    ELSE
      yold=yolder/1.2
    END IF
    CALL Secant_Method(yold,yolder,root,exitflag)
    DO i=1,ntimes
      tend = tstart + treport
      CALL RKF(tstart,tend,Population_Density,neqn,bound,bound1,bound2,epsi1,epsi2,exitflag)
      WRITE(*,*) tend,Population_Density(:neqn)
    END DO

End Program Snail_Worm_Population
