Function ODEfunction(t,y,neqn)
!-------------------------------------------------------------------------------------
!
! This function holds the system of differential equations used in the numberical 
! solutions of ODEs for Engr 326 Lab. And this function will calculate the change
! in snail population and worm population in terms of time.
!
! Where,
! ODEfunction(1) = the snail population growth rate
! ODEfunction(2) = the worm population growth rate
! alpha, and beta= model coefficients given on the problem statement
! y(1) and y(2)  = snail and worm population density, respectively.
! t              = is time 
!------------------------------------------------------------------------------------

 Use Double_Precision
 Use Variable_Library
 Implicit None
 Integer,Intent(in) :: neqn
 Real(dp),Intent(in) :: t
 Real(dp),Dimension(:),Intent(in) :: y
 Real,Dimension(neqn) :: ODEfunction
  write(*,*) "y=", y
  ODEfunction(1) = (alpha1-beta1*y(2))*y(1)
  ODEfunction(2) = (alpha2-beta2*(y(2)/y(1)))*y(2)

End Function ODEfunction