SUBROUTINE RKF(tstart,tend,y,neqn,H,Hmin,Hmax,epsi1,epsi2,exitflag) 
!-------------------------------------------------------------------------------------
!
!
!
!
!
!
!
!-------------------------------------------------------------------------------------

 USE Variable_Library 
 Use Double_Precision
 IMPLICIT NONE
 INTEGER,INTENT(IN) :: neqn 
 Character,INTENT(OUT) :: exitflag 
 REAL(dp),INTENT(IN) :: epsi1, epsi2, Hmin, Hmax, tstart, tend 
 Real(dp),Intent(INOUT) :: H
 REAL(dp),Dimension(:),INTENT(INOUT) :: y 
 !Local Variable 
 REAL(dp) :: re, time, hsave 
 REAL(dp),DIMENSION (neqn) :: k1, k2, k3, k4, k5, k6, y4, ysave
 REAL(dp),Dimension(27),PARAMETER ::  C1=1._dp/5._dp, &            !1
                                      &C2=3._dp/10._dp, &          !2
                                      &c3=3._dp/40._dp, &          !3
                                      &c4=9._dp/40._dp, &          !4
                                      &c5=3._dp/5._dp, &          !5
                                      &c6=3._dp/10._dp, &          !6
                                      &c7=9._dp/10._dp, &          !7
                                      &c8=6._dp/5._dp, &           !8
                                      &c9=11._dp/54._dp, &         !9 
                                      &c10=5._dp/2._dp, &           !10
                                      &c11=70._dp/27._dp, &         !11
                                      &c12=35._DP/27._DP, &         !12
                                      &c13=7._DP/8._DP, &           !13
                                      &c14=1631._DP/55296._DP, &    !14
                                      &c15=175._DP/512._DP, &       !15
                                      &c16=575._DP/13824._DP, &     !16
                                      &c17=44275._DP/110592._DP, &  !17
                                      &c18=253._DP/4096._DP, &      !18
                                      &c19=37._DP/378._DP, &        !19
                                      &c20=250._DP/612._DP, &       !20
                                      &c21=125._DP/594._DP, &       !21
                                      &c22=512._DP/1771._DP, &      !22
                                      &c23=2825._DP/27648._DP, &    !23
                                      &c24=18575._DP/48384._DP, &   !24
                                      &c25=13525._DP/55296._DP, &   !25
                                      &c26=277._DP/14336._DP, &     !26
                                      &c27=1._DP/4._DP            !27

 INTERFACE 
   FUNCTION ODEfunction(t,y,neqn) 
     Use Double_Precision
     Integer,Intent(in) :: neqn
     Real(dp),Intent(in) :: t
     Real(dp),Dimension(:),Intent(in) :: y 
   END FUNCTION ODEfunction 
 END INTERFACE 
 
 time = tstart 
 hsave = H
 DO  
   ysave = y(1:neqn)       !store inicialsfwe repeat step 
   k1 = ODEfunction(time,y,neqn) 
   k2 = ODEfunction(time+c1*h, y(1:neqn)+k1*c1*h, neqn) 
   k3 = ODEfunction(time+c2*h, y(1:neqn)+(c3*k1+c4*k2)*h, neqn) 
   k4 = ODEfunction(time+c5*h, y(1:neqn)+(c6*k1-c7*k2+c8*k3)*h, neqn) 
   k5 = ODEfunction(time+h, y(1:neqn)+(-c9*k1+c10*k2-c11*k3+c12*k4)*h, neqn) 
   k6 = ODEfunction(time+c13*h, y(1:neqn)+&
                    &(c14*k1+c15*k2+c16*k3+c17*k4+c18*k5)*h, neqn) 
   write(*,*) "k1=",k1,"k2=",k2,"k5=",k5
   !Equation 25.45 from Chapra & Canale
   y4 = y(1:neqn)+(c19*k1+c20*k3+c21*k4+c22*k6)*h   
   !Equation 25.46 from Chapra & Canale
   y(1:neqn) = y(1:neqn)+(c23*k1+c24*k3+c25*k4+c26*k5+c27*k6)*h 
   write(*,*) "y4=", y4
   ! Compute 
   re = maxval(abs((y(:neqn)-y4)/y(:neqn))) 
   !Check if error is to large
   IF (re>epsi2) THEN 
     !Check if H is already at minimun value  
     IF (abs(H-Hmin)<10E-6 ) THEN 
       Exitflag = "H is at minimum"
       Return 
     END IF 
     H = H/2.0 
     IF(H<Hmin) H=Hmin 
     y(:neqn) = ysave            !reset 
   !Advance
   ELSE 
     time = time+H 
     !CHeck if error is to small
     IF(re<epsi1)THEN 
       H = H*2 
       IF (H>Hmax) H=Hmax 
     END IF 
     !Check to H is reasonable
     Hsave = H 
     IF (time+H>tend) H = tend - time 
     !Check if done 
     IF (abs(time-tend)<10E-7) THEN 
       Exitflag = "Reached end of time" 
       h = hsave 
       RETURN 
     END IF 
   END IF 
 END DO 
 RETURN

End Subroutine RKF
