Subroutine Secant_Method(x1,x2,x3,flag)
!========================================================================================
!
!
!
!
!========================================================================================
 !Use Double_Precision
 Implicit None
   Integer,Parameter :: dp=selected_real_kind(15)
   Real(dp),Intent(inout) :: x1, x2
   Real(dp),Intent(out) :: X3 
   CHARACTER,INTENT(OUT) :: flag
   Interface
     Function Error(x)
      Use Double_Precision
      REAL(dp) :: Error 
      REAL(dp),INTENT(IN) :: x
      Interface
       Subroutine RKF(tstart,tend,y,neqn,H,Hmin,Hmax,epsi1,epsi2,exitflag)
        USE Double_Precision
        INTEGER,INTENT(IN) :: neqn
        Character,INTENT(OUT) :: exitflag
        REAL(dp),INTENT(IN) :: epsi1, epsi2, Hmin, Hmax, tstart, tend
        REAL(dp),INTENT(INOUT) :: H
        REAL(dp),DIMENSION(:),INTENT(INOUT) :: y
        INTERFACE
         FUNCTION ODEfunction(t,y,neqn)
          USE Double_Precision
          INTEGER,INTENT(IN) :: neqn
          REAL(dp),INTENT(IN) :: t
          REAL(dp),DIMENSION(:),INTENT(IN) :: y
         END FUNCTION ODEfunction
        END INTERFACE
       END SUBROUTINE RKF 
      END INTERFACE
     End Function Error
   End Interface
   ! local variable
   Real(dp),Parameter :: epsi=10E-6
   Integer :: i, counter=0 
   Real(dp) :: f1, f2, f3, dF, trueerror
   
   Do 
     f1 = Error(x1)
     f2 = Error(x2)
     x3 = X2 - f2*((x1-x2)/(f1 - f2))
     f3 = Error(x3)
     counter = counter + 1
     !Exit Criteria-------------------------------
     trueerror = abs(x2-x1)
     If (trueerror.LE.epsi) Return
     If (counter.GE.50) Then
      flag = "Exceed # of iterations could not converge"
      Return
     End If
     x1 = x2
     x2 = x3
   End DO

!   2 format("Iterations", T13,"New Volume Guess", T33,"True Error Percent")
!   3 format(T3,I3,T15,F8.5,T36,F8.7) 

End Subroutine Secant_Method

